<!DOCTYPE html>
<html>
<head>
  <meta charset='utf-8'>
  <meta http-equiv='X-UA-Compatible' content='IE=edge'>
  <title>Page Title</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css">
  <script src='https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.1/jquery.min.js'></script>
  <script src="fabric.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"></script>
</head>
<body>
  <div class="container-fluid">
    <div class="row">
  <div class="col-sm-2">
    <table class="table table-striped">
      <thead>
        <tr>
          <th>image</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>1</td>
        </tr>
      </tbody>
    </table>
  </div>
  <div class="col-sm-7">
  <label><input type="checkbox" id="checkbox" checked="true"><strong style="font-size: 2en">Enabled Create</strong></label>
  <label><input type="checkbox" id="drawRect" checked="true">Draw rectangle bounds</label>
  <label><input type="checkbox" id="onlyOne" checked="true">Only one</label>
  <div class="wrapper" id="canvasBox" style="width:100%;height:100%">
    <canvas id="canvas"  style="border: 2px solid black"></canvas>
  </div>
</div>
<div class="col-sm-3">
  <div class="col-sm-5">
    <input type="textarea" id="note"  cols="10" rows="5" />
  </div>
  <div class="col-sm-7"></div>
  
</div>

</div>
</div>
</div>
  <script>
    const canvas = document.querySelector('#canvas')
    var fabricCanvas = new fabric.Canvas(canvas);

    var elmnt = document.getElementById("canvasBox");
var  canvasScale = 1;
var canvasWidth = 800;
           var canvasHeight = 600;
           var canvasOriginalWidth = 800;
           var canvasOriginalHeight = 600;
           var bgImage;
    var height = elmnt.offsetHeight;
    var width =  elmnt.offsetWidth;

    var widthImage;
    var heightImage;
var img = new Image();
img.onload = function() {
  widthImage = this.width;
  heightImage =  this.height;
  //alert(this.width + 'x' + this.height);
}
img.src = 'visual-reverse-image-search-v2_intro.jpg';

var scale = widthImage / heightImage;
fabricCanvas.setWidth(canvasWidth);
fabricCanvas.setHeight(canvasHeight);

var imageUrl = "visual-reverse-image-search-v2_intro.jpg";

function setCanvasZoom() {
            canvasWidth = canvasOriginalWidth * canvasScale;
            canvasHeight = canvasOriginalHeight * canvasScale;

            fabricCanvas.setWidth(canvasWidth);
            fabricCanvas.setHeight(canvasHeight);
        }

function setCanvasBackgroundImageUrl(url) {
            if (url && url.length > 0) {
              fabric.Image.fromURL(url, function (img) {
                    bgImage = img;
                    scaleAndPositionImage();
                });
            } else {
              fabricCanvas.backgroundImage = 0;
              fabricCanvas.setBackgroundImage('', canvas.renderAll.bind(canvas));

              fabricCanvas.renderAll();
            }
        }


        function scaleAndPositionImage() {
            setCanvasZoom();

            var canvasAspect = canvasWidth / canvasHeight;
            var imgAspect = bgImage.width / bgImage.height;
            var left, top, scaleFactor;

            if (canvasAspect >= imgAspect) {
                var scaleFactor = canvasWidth / bgImage.width;
                left = 0;
                top = -((bgImage.height * scaleFactor) - canvasHeight) / 2;
            } else {
                var scaleFactor = canvasHeight / bgImage.height;
                top = 0;
                left = -((bgImage.width * scaleFactor) - canvasWidth) / 2;

            }

            fabricCanvas.setBackgroundImage(bgImage, fabricCanvas.renderAll.bind(fabricCanvas), {
                top: top,
                left: left,
                originX: 'left',
                originY: 'top',
                scaleX: scaleFactor,
                scaleY: scaleFactor
            });
            fabricCanvas.renderAll();

        }

        setCanvasBackgroundImageUrl(imageUrl);
// Define 
/*
fabricCanvas.setBackgroundImage(imageUrl, fabricCanvas.renderAll.bind(fabricCanvas), {
    // Optionally add an opacity lvl to the image
    backgroundImageOpacity: 0.5,
    // should the image be resized to fit the container?
    backgroundImageStretch: false
});
*/
var groupRec = [];
    const checkbox = document.querySelector('#checkbox')
    let initialPos, bounds, rect, dragging = false, freeDrawing = checkbox.checked
    const options = {
      drawRect: drawRect.checked,
      onlyOne: onlyOne.checked,
      rectProps: {
         stroke: 'red', 
         strokeWidth: 1, 
         fill: ''
      }
    }
    function onMouseDown(e) {
      dragging = true;
      if (!freeDrawing) {
        return
      }
        initialPos = { ...e.pointer }
         bounds = {}
        if(options.drawRect){
        rect = new fabric.Rect({
          left: initialPos.x,
          top: initialPos.y,
          width: 0, height: 0,
         ...options.rectProps,
         note: "",
        });
      /*  rect.toObject = (function(toObject) {
  return function(propertiesToInclude) {
    return fabric.util.object.extend(toObject.call(this, propertiesToInclude), {
      contents:'abc'
    });
  };
})(rect.toObject);*/
        fabricCanvas.add(rect)   
     rect.on('mousedown', function (e) {

console.log('mousedown');
console.log(e);
ShowContentOfRec();
});  
      }
      ShowContentOfRec();
    }
    function update(pointer) {
      if (initialPos.x > pointer.x) {
        bounds.x = Math.max(0, pointer.x)
        bounds.width = initialPos.x - bounds.x
      } else {
        bounds.x = initialPos.x
        bounds.width = pointer.x - initialPos.x
      }
      if (initialPos.y > pointer.y) {
        bounds.y = Math.max(0, pointer.y)
        bounds.height = initialPos.y - bounds.y
      } else {
        bounds.height = pointer.y - initialPos.y
        bounds.y = initialPos.y
      }
      if(options.drawRect){
        rect.left = bounds.x
        rect.top = bounds.y
        rect.width = bounds.width
        rect.height = bounds.height
        rect.dirty = true
        fabricCanvas.requestRenderAllBound()
      }
    }
    function onMouseMove(e) {
      if (!dragging || !freeDrawing) {
        return
      }
      requestAnimationFrame(() => update(e.pointer))
    }
    function onMouseUp(e) {
        dragging = false;
      if (!freeDrawing) {return}
      if (options.drawRect && rect && (rect.width == 0 || rect.height === 0)) {
        fabricCanvas.remove(rect)
      }

      if(!options.drawRect||!rect){
        rect = new fabric.Rect({
          ...bounds, left: bounds.x, top: bounds.y,
         ...options.rectProps,
         note: "",
        });

       /* rect.toObject = (function(toObject) {
  return function(propertiesToInclude) {
    return fabric.util.object.extend(toObject.call(this, propertiesToInclude), {
      contents:'abc'
    });
  };
})(rect.toObject);*/

         fabricCanvas.add(rect)
         rect.on('mousedown', function (e) {

console.log('mousedown');
console.log(e);
ShowContentOfRec();
});  
        rect.dirty = true
        fabricCanvas.requestRenderAllBound()
      }
      rect.setCoords() // important! 
      options.onlyOne && uninstall()
      ShowContentOfRec();
    }
    function install() {
      freeDrawing = true; dragging = false; rect = null
      checkbox.checked = true
      fabricCanvas.on('mouse:down', onMouseDown);
      fabricCanvas.on('mouse:move', onMouseMove);
      fabricCanvas.on('mouse:up', onMouseUp);
    }
    function uninstall() {
      freeDrawing = false; dragging = false; rect = null
      checkbox.checked = false
      fabricCanvas.off('mouse:down', onMouseDown);
      fabricCanvas.off('mouse:move', onMouseMove);
      fabricCanvas.off('mouse:up', onMouseUp);
    }

    // the following is OOT - it's just for the controls above
    checkbox.addEventListener('change', e =>
      e.currentTarget.checked ? install() : uninstall()
    )
    document.querySelector('#drawRect').addEventListener('change', e =>{
      options.drawRect = e.currentTarget.checked
    })
     document.querySelector('#onlyOne').addEventListener('change', e =>{
      options.onlyOne = e.currentTarget.checked
    })
    freeDrawing && install()
    /*
    document.querySelector('#changeCanvasPosition').addEventListener('click', () => {
      const el = document.querySelector(`.wrapper`)
      el.style.marginTop = Math.trunc(Math.random() * 300) + 'px'
      el.style.marginLeft = Math.trunc(Math.random() * 200) + 'px'
    })
*/
    $('html').keyup(function(e){
        if(e.keyCode == 46) {
            deleteSelectedObjectsFromCanvas();
        }
});    
    function deleteSelectedObjectsFromCanvas(){
    var selection = fabricCanvas.getActiveObject();
    if (selection.type === 'activeSelection') {
        selection.forEachObject(function(element) {
            console.log(element);
            fabricCanvas.remove(element);
        });
    }
    else{
      fabricCanvas.remove(selection);
    }
    fabricCanvas.discardActiveObject();
    fabricCanvas.renderAll();
}

function getCoordinates(){
 var coords = [];
 fabricCanvas.forEachObject(function(obj){
   var prop = {
     left : obj.left,
     top : obj.top,
     width : obj.width,
     height : obj.height,
     note: obj.note
   };
   coords.push(prop);
 });
 console.log(coords)
}

function ShowContentOfRec(){
    var selection = fabricCanvas.getActiveObject();
    if(selection){
    if (selection.type === 'activeSelection') {
      /*
        selection.forEachObject(function(element) {
            console.log(element);
            fabricCanvas.remove(element);
        });*/
    }
    else{
      $('#note').val(selection.note);
    }
  }
}
$('input[type=textarea]').bind('input propertychange', function() {
     var selection = fabricCanvas.getActiveObject();
     if(selection){
    if (selection.type === 'activeSelection') {
      /*
        selection.forEachObject(function(element) {
            console.log(element);
            fabricCanvas.remove(element);
        });*/
    }
    else{
      selection.note =  this.value;
    } 
     }
});


  </script>
</body>

</html>